<?php
/**
* @version		fatal_catcher.php 
* @copyright	Copyright (C) 2005 - 2013 RuposTel.com
* @license		GNU General Public License version 2 or later; see LICENSE.txt
*/

// no direct access
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');

class plgSystemFatal_catcher extends JPlugin {
	public static $email; 
	public static $errortype; 
	public static $writelog; 
	public static $tracelog; 
	public static $track404;
	public static $referer; 
	public static $errorCallbacks; 
	public static $request;
	public static $fileTrace; 
	public static $fileLine;
	
	public static function registerErrorCallback($arr) {
		if (empty(self::$errorCallbacks)) self::$errorCallbacks = array(); 
		self::$errorCallbacks[] = $arr; 
	}
	public static function registerHandlers() {
		
		if (function_exists('register_shutdown_function'))
		{
			
			
			register_shutdown_function( "fatal_error_catcher" );
		}

		if (function_exists('set_error_handler')) {
			//reset:
			set_error_handler(null); 
			set_error_handler('fatal_catcher_exceptions_error_handler'); 
		}

		if (function_exists('set_exception_handler')) {
			set_exception_handler('fatal_catcher_exceptions_error_handler2');
		}
	}

	public static function test() {
		error_log('test fatal catcher'); 
	}
	function __construct(& $subject, $config)
	{
		
		if (function_exists('ini_set')) {
			$test = ini_set('zend.exception_ignore_args', '0'); 
			
		}
		parent::__construct($subject, $config);
		plgSystemFatal_catcher::$referer = ''; 
		if (!empty($_REQUEST)) {
			plgSystemFatal_catcher::$request = $_REQUEST; 
		}
		else {
			plgSystemFatal_catcher::$request = array(); 
		}
		if (isset($this->params))
		{
			$email = $this->params->get('email'); 
			plgSystemFatal_catcher::$email = $email; 
			
			$errortype = $this->params->get('errortype', 0); 
			plgSystemFatal_catcher::$errortype = (int)$errortype; 
			$writelog = $this->params->get('writelog', 0); 
			plgSystemFatal_catcher::$writelog = (int)$writelog; 
			
			plgSystemFatal_catcher::$track404 = $this->params->get('track404', false); 
			if (!empty($_SERVER["HTTP_REFERER"])) {
				plgSystemFatal_catcher::$referer = $_SERVER["HTTP_REFERER"];
			}
			else {
				plgSystemFatal_catcher::$referer = ''; 
			}
		}
		if (method_exists('JError', 'setErrorHandling')) {
			JError::setErrorHandling(E_ERROR, 'callback', array('plgSystemFatal_catcher', 'handleError')); 
		}
		
		plgSystemFatal_catcher::registerHandlers(); 
		
	}
	
	public static function getTrace($ex) {
		
		
		$trace = ''; 
		if (method_exists($ex, 'getFile'))
	$file = $ex->getFile(); 
	if (method_exists($ex, 'getLine'))
	$line = $ex->getLine(); 
	
	$trace .= $file.':'.$line."\n"; 
	if (!empty($file))
	if (empty(plgSystemFatal_catcher::$fileTrace)) {
		plgSystemFatal_catcher::$fileTrace = $file; 
		
	}
	if (!empty($line))
	if (empty(plgSystemFatal_catcher::$fileLine)) {
		plgSystemFatal_catcher::$fileLine = $line; 
		
	}
	
	if (method_exists($ex, 'getTrace')) {
			$trace .= "\nStandard Exception Backtrace with Args: \n"; 
			$x = $ex->getTrace(); 
			$lines = array(); 
			foreach ($x as $l) {
						$line = $l['file'].':'.$l['line']; 
						
						if (!empty($l['args'])) {
							$arr = array(); 
							foreach ($l['args'] as $arg) {
								if (is_string($arg)) {
									$arr[] = '"'.$arg.'"'; 
								}
								else {
									if (is_object($arg)) {
									$arr[] = get_class($arg); 
									}
									else {
										$arr[] = '_'; 
									}
								}
								
							}
							$line .= ' ('.implode(',', $arr).') '; 
						}
						$trace .= $line."\n"; 
					}
			
			
		}
		else 
		{
			
	
			if (method_exists($ex, 'getTraceAsString')) 
			{
			$trace .= "\nStandard Exception Backtrace: \n"; 
			$trace .= $ex->getTraceAsString(); 
			}
		}
		
	//if (empty($trace)) 
	{
		
		if (function_exists('xdebug_get_function_stack'))
		{
			$trace .= "\nStandard Xdebug Backtrace: \n"; 
			$trace .= var_export(xdebug_get_function_stack(), true);
		}
		else {
		$x = debug_backtrace(); 
		$trace .= "\nStandard Backtrace: \n"; 
		foreach ($x as $l) {
			$trace .= @$l['file'].' '.@$l['line']."\n";
		}
		}
	}
		
		return $trace; 
		
	}
	
	public function onError($e) {
		
		
		
		if (method_exists($e, 'getCode')) {
			$code = $e->getCode(); 
			if (empty($code)) {
				 
				$msg = $e->getMessage().' in file '.$e->getFile().':'.$e->getLine();
				
				
				if (empty(plgSystemFatal_catcher::$tracelog)) {
					plgSystemFatal_catcher::$tracelog = plgSystemFatal_catcher::getTrace($e); 
				}
				
				
				$e = new Exception($msg, 500, $e); 
			}
		}
		
		fatal_catcher_exceptions_error_handler2($e); 
		return true; 
	}
	public static function handleError($e) {
		fatal_catcher_exceptions_error_handler2($e); 
	}
	
	public static function onAfterDispatch() {
		plgSystemFatal_catcher::registerHandlers(); 
	}
	public static function onAfterInitialise() {
		plgSystemFatal_catcher::registerHandlers(); 
	}
	public static function onAfterRoute() {
		plgSystemFatal_catcher::registerHandlers(); 
	}
	
	//http://php.net/manual/en/function.set-error-handler.php
	public static function mapErrorCode($code, &$mytype='') {
		$error = $log = null;
		$mytype = ''; 
		switch ($code) {
		case E_PARSE:
			$mytype = 'E_PARSE'; 
			$error = 'Fatal Error';
			$log = LOG_ERR;
			break;
		case E_ERROR:
			$mytype = 'E_ERROR'; 
			$error = 'Fatal Error';
			$log = LOG_ERR;
			break;
		case E_CORE_ERROR:
			$mytype = 'E_CORE_ERROR'; 
			$error = 'Fatal Error';
			$log = LOG_ERR;
			break;
		case E_COMPILE_ERROR:
			$mytype = 'E_COMPILE_ERROR'; 
			$error = 'Fatal Error';
			$log = LOG_ERR;
			break;
		case E_USER_ERROR:
			$mytype = 'E_USER_ERROR'; 
			$error = 'Fatal Error';
			$log = LOG_ERR;
			break;
		case E_WARNING:
			$mytype = 'E_WARNING'; 
			$error = 'Warning';
			$log = LOG_WARNING;
			break;
		case E_USER_WARNING:
			$mytype = 'E_USER_WARNING'; 
			$error = 'Warning';
			$log = LOG_WARNING;
			break;
		case E_COMPILE_WARNING:
			$mytype = 'E_COMPILE_WARNING'; 
			$error = 'Warning';
			$log = LOG_WARNING;
			break;
		case E_RECOVERABLE_ERROR:
			$mytype = 'E_RECOVERABLE_ERROR'; 
			$error = 'Warning';
			$log = LOG_WARNING;
			break;
		case E_NOTICE:
			$mytype = 'E_NOTICE'; 
			$error = 'Notice';
			$log = LOG_NOTICE;
			break;
		case E_USER_NOTICE:
			$mytype = 'E_USER_NOTICE'; 
			$error = 'Notice';
			$log = LOG_NOTICE;
			break;
		case E_STRICT:
			$mytype = 'E_STRICT'; 
			$error = 'Notice';
			$log = LOG_NOTICE;
			break;
		case E_DEPRECATED:
			$mytype = 'E_DEPRECATED'; 
			$error = 'Deprecated';
			$log = LOG_NOTICE;
			break;
		case E_USER_DEPRECATED:
			$mytype = 'E_USER_DEPRECATED';
			$error = 'Notice';
			$log = LOG_NOTICE;
			break;
		 default: 
			$mytype = 'E_UNKNOWN_ERROR';
			$error = $code; 
			$log = LOG_NOTICE;
			break;
		}
		//return array('error'=>$error, 'log'=>$log);
		return $error;
	}
	
	
	public function onAfterRouteTestError() {
		$db = JFactory::getDBO(); 
		$q = 'select testerror from testerror where 1=1'; 
		$db->setQuery($q); 
		$db->loadResult(); 
	}
	
	
	public function onSendSystemErrorEmail($subject, $msgs=array()) {
	  
	  if (!empty(plgSystemFatal_catcher::$email)) {
		$email = plgSystemFatal_catcher::$email; 
	  }
	

	
	$config = JFactory::getConfig();	
	if (method_exists($config, 'getValue'))
	$sender = array( $config->getValue( 'config.mailfrom' ), $config->getValue( 'config.fromname' ) );
	else
	$sender = array( $config->get( 'mailfrom' ), $config->get( 'fromname' ) );
	
	if (empty($email)) 
	{
		$email = $sender[0]; 
		plgSystemFatal_catcher::$email = $email; 
	}
	
	if (!empty($email))
	{
		
		$mailer = JFactory::getMailer();		
		if (strpos(plgSystemFatal_catcher::$email, ',') !== false) {
			$ea = explode(',', plgSystemFatal_catcher::$email); 
			foreach ($ea as $ee) {
				$ee = trim($ee); 
				if (!empty($ee)) {
					$mailer->addRecipient( $ee );
				}
			}
			
		}
		else {
			$mailer->addRecipient( $email );
		}
		
		
		
		
		
		
		$mailer->setSubject(  html_entity_decode( $subject) );
		$mailer->isHTML( false );
		
		$body = "RuposTel.com plg_system_fatal_catcher plugin detected a problem with your site. \nYour site caused a blank screen upon a visit of this URL: \n\n"; 

		$pageURL = 'http';
		if ((isset($_SERVER['HTTPS'])) && ($_SERVER["HTTPS"] == "on")) {$pageURL .= "s";}
		$pageURL .= "://";
		if (($_SERVER["SERVER_PORT"] != "80") && ($_SERVER['SERVER_PORT'] != '443')) {
			$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
		} else {
			$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		}		
		$body .= $pageURL."\n\n"; 
		if (!empty(plgSystemFatal_catcher::$referer)) {
			$body .= 'HTTP_REFERER: '.plgSystemFatal_catcher::$referer."\n\n"; 
		}
		$body .= 'Error message data: '."\n\n"; 
		
		
		
		if (is_string($msgs)) {
			$body .= $msgs; 
		}
		else {
			$body .= "<pre>\n".var_export($msgs, true)."\n</pre>\n\n"; 
		}
		$body .= "\n\nTo disable these emails proceed to your Extensions -> Plug-in manager -> disable plg_system_fatal_catcher \n";
		$body .= "It is very important that you fix all php fatal errors on your site. Resend this email to your developer."; 
		
		
		{
			
			if (function_exists('xdebug_get_function_stack'))
			{
				
				
				$body .= "\n\nXDebug Backtrace: \n"; 
				$body .= var_export(xdebug_get_function_stack(), true);
				//$x = debug_backtrace(); 
				//foreach ($x as $l) $body .= @$l['file'].' '.@$l['line']."\n"; 
				$body .= "\n"; 
			}
			else {
				$x = debug_backtrace(); 
				if (!empty($x)) 
				{
				$body .= "\n\nPossible Backtrace: \n"; 
				foreach ($x as $l) {
					if (isset($l['file']) && (isset($l['line']))) {
						$body .= $l['file'].':'.$l['line']."\n"; 
					}
				}
				$body .= "\n"; 
				}
			}
			
			
		}
		
		$body .= "\n_SERVER:\n".var_export($_SERVER, true)."\n";
		if (!empty(plgSystemFatal_catcher::$request)) {
			$body .= "\n_REQUEST:\n<pre>\n/*<![CDATA[*/\n".str_replace(']]>', '&#93;&#93;&gt;', var_export(plgSystemFatal_catcher::$request, true))."\n/*]]>*/\n</pre>\n";
		}
		
		$mailer->setBody( $body );
		$mailer->setSender( $sender );
		try {
			$res = $mailer->Send();
		}
		catch(Exception $e) {
			
		}
		
		if (file_exists(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_onepage'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'errors.php')) {
			require_once(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_onepage'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'errors.php');
			$err = new stdClass(); 
			$err->fatal_error = $body; 
			OPCErrors::store('plg_system_fatal_catcher: '.$subject, $err); 
			
		}
	 }
    }

}


// the definition of these functions is outside the plugin code, so it can load immidiately after joomla initiliazation


function fatal_error_catcher()
{
	
	//if (function_exists('fastcgi_finish_request')) fastcgi_finish_request(); 
	
	$errfile = "unknown file";
	$errstr  = "shutdown";
	$errno   = E_CORE_ERROR;
	$errline = 0;

	$error = error_get_last();



	if( $error !== NULL) {
		$errno   = $error["type"];
		if (empty(plgSystemFatal_catcher::$errortype)) { 
			$types = array(E_ERROR,  E_PARSE, E_CORE_ERROR, E_COMPILE_ERROR, E_RECOVERABLE_ERROR); 
			
			if (($errno >= 1000) && ($errno <= 5000)) {
				$errno = E_ERROR;
			}
			
			if (!in_array($errno, $types)) return;
		} 
		
		
		
		
		

		
		$errfile = $error["file"];
		$errline = $error["line"];
		$errstr  = $error["message"];
		$date = JFactory::getDate(); 
		fatal_catcher_exceptions_error_handler($errno, $errstr, $errfile, $errline); 
		
		
	}
	return false; 
}

function fatal_catcher_exceptions_error_handler2($ex) {
	
	$msg = $ex->getMessage(); 
	
	$code = 0; 
	$file = ''; 
	if (!empty(plgSystemFatal_catcher::$fileTrace)) {
			$file = plgSystemFatal_catcher::$fileTrace; 
		}
	$line = 'unknown'; 
	if (!empty(plgSystemFatal_catcher::$fileLine)) {
			$line = plgSystemFatal_catcher::$fileLine; 
		}
	$trace = ''; 
	if (method_exists($ex, 'getCode'))
	{
	$code = $ex->getCode(); 
	$codeOrig = $code; 
	}
	
	if ($code === 404) {
		if (empty(plgSystemFatal_catcher::$track404)) {
			if (method_exists('JErrorPage', 'render')) {
				JErrorPage::render($ex); 
			}
			return true; 
		}
	}
	/*
	if (method_exists($ex, 'getFile'))
	$file = $ex->getFile(); 
	if (method_exists($ex, 'getLine'))
	$line = $ex->getLine(); 
	
	$trace .= $file.':'.$line."\n"; 
	
	
	
	if (method_exists($ex, 'getTrace')) {
			$x = $ex->getTrace(); 
			$lines = array(); 
			foreach ($x as $l) {
						$line = $l['file'].':'.$l['line']; 
						
						if (!empty($l['args'])) {
							$arr = array(); 
							foreach ($l['args'] as $arg) {
								if (is_string($arg)) {
									$arr[] = '"'.$arg.'"'; 
								}
								else {
									if (is_object($arg)) {
									$arr[] = get_class($arg); 
									}
									else {
										$arr[] = '_'; 
									}
								}
								
							}
							$line .= ' ('.implode(',', $arr).') '; 
						}
						$trace .= $line."\n"; 
					}
			
			
		}
		else 
		{
			
	
			if (method_exists($ex, 'getTraceAsString'))
			$trace .= $ex->getTraceAsString(); 
		}
		*/
	$cl = get_class($ex); 
	
	
	
	if (($cl === 'JDatabaseExceptionExecuting') || (($code > 1000) && ($code <= 5000))) {
		
		$code = E_ERROR; 
		if (class_exists('ReflectionObject')) {
			$refObject   = new ReflectionObject( $ex );
			if ($refObject->hasProperty('query')) {
			$prop = $refObject->getProperty( 'query' );
			
			$q = ''; 
			if (!empty($prop) && (method_exists($prop, 'setAccessible'))) {
				$prop->setAccessible( true );
				$q = $prop->getValue($ex); 
			}
			
			$msg .= "\n\n".'Query: '."\n".$q."\n\n"; 
			}
			else {
				
					
					if (method_exists($ex, 'getTrace')) {
			$x = $ex->getTrace(); 
			$lines = array(); 
			foreach ($x as $l) {
						$line = $l['file'].':'.$l['line']; 
						
						if ((isset($l['args'][1])) && (is_string($l['args'][1]))) {
							$query = $l['args'][1]; 
							$msg .= "\n\n".'Last Estimated Query: '."\n".$query."\n\n"; 
							
							
							break; 
						}
						
					}
				}
			
			
		
					
			}
		}
		
		
	}
	
	
	if (($code === 500) || (stripos($cl, 'Exception')!==false)) {
		
		$code = E_ERROR; 
		
		
		
	}
	
	if ((empty($code)) || ($code == E_WARNING)) {
		
		$code = E_ERROR; 
	}
	
	if ($code > 1000) {
		$code = E_ERROR; 
	}
	
	
	
	if (empty(plgSystemFatal_catcher::$tracelog)) {
		plgSystemFatal_catcher::$tracelog = plgSystemFatal_catcher::getTrace($ex); 
	}
	/*
	if (empty($trace)) 
	{
		plgSystemFatal_catcher::$tracelog = ''; 
		if (function_exists('xdebug_get_function_stack'))
		{
			$trace .= "\nStandard Xdebug Backtrace: \n"; 
			$trace .= var_export(xdebug_get_function_stack(), true);
		}
		else {
		$x = debug_backtrace(); 
		foreach ($x as $l) {
			$trace .= "\nStandard Backtrace: \n"; 
			$trace .= @$l['file'].' '.@$l['line']."\n";
		}
		}
	}
	else 
	{
		
	}
	
	
	
	plgSystemFatal_catcher::$tracelog = $trace; 
	*/
	if ($codeOrig !== $code) {
		$msg = $codeOrig.': '.$msg; 
	}
	$errstr = $msg; //.' @ '.$file.':'.$line; 
	
	fatal_catcher_exceptions_error_handler($code, $errstr, $file, $line); 
	
	
	
	if (method_exists('JErrorPage', 'render')) {
		JErrorPage::render($ex); 
	}
	
	return TRUE; 
}

function fatal_catcher_exceptions_error_handler($errno, $errstr, $errfile, $errline) {
	
	//1064 -> joomla sql error
	$mytype = ''; 
	$severity = plgSystemFatal_catcher::mapErrorCode($errno, $mytype); 
	if ($severity !== $errno)
	if (empty(plgSystemFatal_catcher::$errortype)) {
		
		$types = array(E_ERROR,  E_PARSE, E_CORE_ERROR, E_COMPILE_ERROR, E_RECOVERABLE_ERROR);
		//mysqlerrors:
		if (($errno >= 1000) && ($errno <= 5000)) {
			$errno = E_ERROR;
		}
		if (!in_array($errno, $types)) return FALSE;	
	}
	
	$types = array('E_USER_DEPRECATED',  'E_DEPRECATED', 'E_STRICT', 'E_USER_NOTICE', 'E_NOTICE', 'E_COMPILE_WARNING', 'E_USER_WARNING', 'E_WARNING');
	if (in_array($mytype, $types)) return FALSE; 
	
	
	//COM_VIRTUEMART_CATEGORY_NOT_FOUND
	$x = debug_backtrace(); 
	if (($errno === 1) && (strpos($errstr, 'VirtueMart') !== false) && (strpos($errstr, 'not found') !== false)) {
		
		if (empty(plgSystemFatal_catcher::$track404)) return; 
		
	}
	
	if ($errno === 1) {
		if (isset($_SERVER["REQUEST_URI"]))
		if ($_SERVER["REQUEST_URI"] === '/administrator/index.php?option=com_ajax&format=json') {
		 	return; 
		}
	}
	///administrator/index.php?option=com_ajax&format=json
	
	
	if (is_null($errno)) return FALSE; 
	
	if (empty($errfile)) {
		if (!empty(plgSystemFatal_catcher::$fileTrace)) {
			$errfile = plgSystemFatal_catcher::$fileTrace; 
		}
	}
	if ((empty($errline)) || ($errline === 'unknown')) {
		if (!empty(plgSystemFatal_catcher::$fileLine)) {
			$errline = plgSystemFatal_catcher::$fileLine; 
		}
	}
	
	
	$date = JFactory::getDate(); 
	$dates = $date->toISO8601();
	if (strpos($errstr, ' in file') !== false) {
		$dataMsg = $errstr; 
	}
	else {
		$dataMsg = $mytype.':'.$errno.' '.$errstr.' in file: '.$errfile.' line: '.$errline." \n\ntimestamp: ".$dates."\n";
	}

	if (!empty(plgSystemFatal_catcher::$writelog)) {
		$f = JPATH_SITE.DIRECTORY_SEPARATOR.'administrator'.DIRECTORY_SEPARATOR.'logs'.DIRECTORY_SEPARATOR.'php_errors.log.php'; 
		if (!file_exists($f))
		{
			// some versions of php's have a broken compiler if the start tag is inside a string
			$data = urldecode('%3C%3F').'php die(); ?>'."\n".$dataMsg; 
			jimport( 'joomla.filesystem.file' );
			//@JFile::write($f, $data);  -> we do not use joomla FTP layer here because it does not support incremental writes
			@file_put_contents($f, $data); 
		}
		else
		{
			@file_put_contents($f, $dataMsg, FILE_APPEND); 
		}
	}
	
	if (!empty(plgSystemFatal_catcher::$email)) {
		$email = plgSystemFatal_catcher::$email; 
	}
	

	
	$config = JFactory::getConfig();	
	if (method_exists($config, 'getValue'))
	$sender = array( $config->getValue( 'config.mailfrom' ), $config->getValue( 'config.fromname' ) );
	else
	$sender = array( $config->get( 'mailfrom' ), $config->get( 'fromname' ) );
	
	if (empty($email)) 
	{
		$email = $sender[0]; 
		plgSystemFatal_catcher::$email = $email; 
	}
	
	if (!empty($email))
	{
		
		$mailer = JFactory::getMailer();		
		if (strpos(plgSystemFatal_catcher::$email, ',') !== false) {
			$ea = explode(',', plgSystemFatal_catcher::$email); 
			foreach ($ea as $ee) {
				$ee = trim($ee); 
				if (!empty($ee)) {
					$mailer->addRecipient( $ee );
				}
			}
			
		}
		else {
			$mailer->addRecipient( $email );
		}
		
		
		
		
		
		$subject = 'Fatal Error Detected on your Joomla Site'; 
		$mailer->setSubject(  html_entity_decode( $subject) );
		$mailer->isHTML( false );
		
		$body = "RuposTel.com plg_system_fatal_catcher plugin detected a problem with your site. \nYour site caused a blank screen upon a visit of this URL: \n\n"; 
		$pageURL = '(URL not set)'; 
		if (isset($_SERVER["SERVER_NAME"])) {
		$pageURL = 'http';
		if ((isset($_SERVER['HTTPS'])) && ($_SERVER["HTTPS"] == "on")) {$pageURL .= "s";}
		$pageURL .= "://";
		if (($_SERVER["SERVER_PORT"] != "80") && ($_SERVER['SERVER_PORT'] != '443')) {
			$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
		} else {
			$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		}		
		}
		$body .= $pageURL."\n\n"; 
		if (!empty(plgSystemFatal_catcher::$referer)) {
			$body .= 'HTTP_REFERER: '.plgSystemFatal_catcher::$referer."\n\n"; 
		}
		$body .= 'Error message data: '."\n"; 
		$body .= $dataMsg; 
		$body .= "\n\nTo disable these emails proceed to your Extensions -> Plug-in manager -> disable plg_system_fatal_catcher \n";
		$body .= "It is very important that you fix all php fatal errors on your site. Resend this email to your developer."; 
		
		if (strpos($dataMsg, 'memory')===false)
		{
			if (!empty(plgSystemFatal_catcher::$tracelog)) {
				$body .= "\n\nBacktrace: \n"; 
				$body .= plgSystemFatal_catcher::$tracelog;
				//$x = debug_backtrace(); 
				//foreach ($x as $l) $body .= @$l['file'].' '.@$l['line']."\n"; 
				$body .= "\n"; 
			}
			else
			if (function_exists('xdebug_get_function_stack'))
			{
				
				
				$body .= "\n\nXDebug Backtrace: \n"; 
				$body .= var_export(xdebug_get_function_stack(), true);
				//$x = debug_backtrace(); 
				//foreach ($x as $l) $body .= @$l['file'].' '.@$l['line']."\n"; 
				$body .= "\n"; 
			}
			else {
				$x = debug_backtrace(); 
				if (!empty($x)) 
				{
				$body .= "\n\nPossible Backtrace: \n"; 
				foreach ($x as $l) {
					if (isset($l['file']) && (isset($l['line']))) {
						$body .= $l['file'].':'.$l['line']."\n"; 
					}
				}
				$body .= "\n"; 
				}
			}
			
			
		}
		
		$body .= "\n_SERVER:\n".var_export($_SERVER, true)."\n";
		if (!empty(plgSystemFatal_catcher::$request)) {
			$body .= "\n_REQUEST:\n<pre>\n/*<![CDATA[*/\n".str_replace(']]>', '&#93;&#93;&gt;', var_export(plgSystemFatal_catcher::$request, true))."\n/*]]>*/\n</pre>\n";
		}
		
		$mailer->setBody( $body );
		$mailer->setSender( $sender );
		try {
		$res = $mailer->Send();
		}
		catch(Exception $e) {
			
		}
		
		if (file_exists(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_onepage'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'errors.php')) {
			require_once(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_onepage'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'errors.php');
			$err = new stdClass(); 
			$err->fatal_error = $body; 
			OPCErrors::store('plg_system_fatal_catcher: '.$subject, $err); 
			
		}
		
		if (!empty(plgSystemFatal_catcher::$errorCallbacks)) {
			foreach (plgSystemFatal_catcher::$errorCallbacks as $ind=>$c) {
				if (is_callable($c)) {
					try {
						call_user_func($c, $body); 
					}
					catch(Exception $e) {
						//silent ignore 
					}
				}
				unset(plgSystemFatal_catcher::$errorCallbacks[$ind]); 
			}
		}
		
	}
	return FALSE; 
}

plgSystemFatal_catcher::registerHandlers(); 
